signature FIELD_STR =
    sig
	datatype 'a report =
	    GOT of 'a
	  | EMPTY 
	  | ERROR of string

	datatype 'a fld =
	    F of {name: string,
		  read: string list -> 'a option * string list}

	datatype 'a node =
	    Tree of  {key: string,
		      data: 'a,
		      kids: 'a node list}

	val merge : string list -> string
	val test : 'a fld -> string -> bool
	val read : 'a fld -> string list -> 'a report * string list
	val readall : 'a fld list -> string list -> 'a list report
	val readstruct : string * 'a fld list -> string list -> 'a list report * string list

	val rawSegment : string * 'a fld list -> string list -> string list list report * string list
	val segment : string * 'a fld list -> string list -> string list report * string list
	val unsegment : string * 'a fld list -> string list -> string

	val readBool : string list -> bool option * string list
	val readInt : string list -> int option * string list
	val readStrings : string list -> string list option * string list

	val wrapReader : (('a -> 'b option) * (string list -> 'a option * string list) ->
			  (string list -> 'b option * string list))

	(* assumes guys are delimited by ',' or ';' *)
	val readListOf : ((string list -> 'a option * string list) ->
			  (string list -> 'a list option * string list))
    end
