
signature CALL =
    sig
	structure Term : TERM

	type call
	type init
	type info

	datatype presupp =
	    Presupposed
	  | Asserted

	datatype pb =
	    V of presupp
	  | E of int

	val newPPVar : unit -> int
	val createCall: Term.term -> call
	val readCall: int -> string list -> call option * string list

	val writeHead : call -> string
	val writeCall : call -> string
	val printCall: call -> unit

	val writeprettyCall: info -> call -> string
	val prettyprintCall: info -> call -> unit

	val mkInfo : unit -> info
	val printInfo : info -> unit

	val mkInit : unit -> init
	val printInit : init -> unit

	val newcopyCall : call * init -> call * init
	val copycallAfter : call * init * init -> call * init

	val match : call * call * info -> (pb * info) option

	val getKeyInit : (info * Term.IntSet.intset * Term.Patheq.pathpt ->
			  Term.init Term.IntMap.intmap)
	val getInit : (info * call * Term.Patheq.pathpt -> 
		       Term.init Term.IntMap.intmap)
	val setWithInit: 
	    info * init * Term.init Term.IntMap.intmap * (pb * presupp) option -> 
	    info option
	    
	val overlap : call * call -> bool
	val checkGround : info -> call -> bool
	val checkKeyGround : info -> call -> bool
	val duplicates : call * info * call * info -> bool

	val matchkeys : info -> int * int -> bool
	val readout : info * int -> Term.term Term.desc

	val cacheTermApp : (Term.term -> '1b) -> Term.term -> '1b
    end
