
signature CONSTRAINT =
    sig
	structure Formula : FDB;
	structure Call : CALL;
	sharing Call.Term = Formula.Term;
	    
	type problem
	    
	val newProblem : 
	    (Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  * 
				      Formula.formula -> 
				      unit Formula.proof list)) -> problem

	val printProblem : problem -> unit

	val relax : problem -> problem

	val addConstraint : 
	    problem * Formula.formula * Formula.Term.init Formula.Term.IntMap.intmap *
	    Call.info *  Formula.Term.init Formula.Term.IntMap.intmap *
	    Call.info -> problem

	val sizes : problem -> int list
	val worksizes : problem -> int list

	val numfree : problem -> int
    end
