(*
 * feature-sig.sml
 *
 *)

signature FEATURES =
    sig
	type features
	type binding

	structure Symbol :SYMBL;
	structure SymbolSet : ORD_SET;

	val isVariableS : string -> bool
	val isVariable : features -> bool
	val isConstant : features -> bool
	val makeVariable : Symbol.symbol -> features
	val genVariable : unit -> features
	val genConst : unit -> features
	val topFeature : unit -> features

	val readFeatures :string list -> features option * string list
	val emptyBinding : unit -> binding

	val writeFeatures : features -> string
	val printFeatures : features -> unit

	val writeprettyFeatures : binding -> features -> string
	val prettyprintFeatures : binding -> features -> unit

	val newcopyFeatures : features * binding -> features * binding
	val unifyFeatures : features * features * binding -> 
	    (features * binding) option
	val roughSubsumes : features * features * binding -> 
	    bool

	sharing type Symbol.symbol = SymbolSet.item
    end
