(*
 * morph-sig.sml
 *
 *)

signature MORPH =
    sig
	structure Features : FEATURES

	type entry

	val readEntry : string list -> (entry option * string list)
	val printEntry : entry -> unit
	val match : Features.features * Features.binding -> entry -> string option
	val key : entry -> string
    end

signature MORPHDB =
    sig
	structure Morph : MORPH

	type morphdb

	val newdb : unit -> morphdb
	val addEntry : morphdb -> Morph.entry -> unit
	val findForm : morphdb -> 
	    string * Morph.Features.features * Morph.Features.binding -> string option

	val dump : morphdb -> unit
    end

