
signature ITAG =
    sig
	structure Tag : TAG;
	structure Formula : FDB;
	structure Call : CALL;

	type entry
	type entry_part
	type taglex

	datatype match =
	    M of {info: Call.info,
		  call: Call.call,
		  init: Call.init,
		  tree: Tag.tree}

	val entryFields:
	    Formula.Patheq.Modspec.collection ->
	    entry_part FieldStr.fld list

	val fieldTreeInit : ((string * string list) FieldStr.node * string list)

	val treeDataField : Tag.data FieldStr.fld 
	val treeField : string list FieldStr.fld 
	val treeEntryField : entry_part FieldStr.fld

	val readEntry: 
	    Formula.Patheq.Modspec.collection ->
	    string list -> entry option * string list

	val newTaglex : unit -> taglex
	val addEntry : taglex * entry -> taglex

	val writerecEntry : (Tag.tinst * Call.info) -> ((string * string list) FieldStr.node)

	val printEntry: entry -> unit
	val printMatch : match -> unit
	val printTaglex : taglex -> unit

	val specOrder :
	    ((Formula.Term.init Formula.Term.IntMap.intmap  *
	      Formula.formula ->
	      unit Formula.proof list) ->
	     taglex -> taglex)

	val matchEntry :
	    (Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  * 
				      Formula.formula -> 
				      unit Formula.proof list)) ->
	    Call.call * Call.info ->
	    entry -> match option
	    
	val matchAll : 
	    (Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  * 
				      Formula.formula -> 
				      unit Formula.proof list)) ->
	    (Call.call * Call.info) list ->
	    taglex -> match list
	    
	sharing Call.Term = Formula.Term;
	sharing type Tag.data = Call.call;
		sharing type Tag.datastate = Call.init;
    end	    
