
signature TAG =
    sig
	structure Features : FEATURES

	type data
	type datastate
	type address

	datatype kind = 
	    ToSubst
	  | ToAdjoin

	datatype tkind =
	    Initial 
	  | Auxiliary of address
	    
	datatype opportunity = 
	    OP of {kind: kind,
		   address: address,
		   match: Features.features,
		   data: data}

	datatype cinfo =
	    CI of {address: address,
		   words: string list,
		   match: Features.features,
		   state: datastate}

	type tree
	type tree_part
	type tinst

	val treeFields : (data FieldStr.fld -> string -> 
			  tree_part FieldStr.fld list *
			  tree_part FieldStr.fld list)
	    
	val mkData : data -> tree_part
	val segmentTree : (data FieldStr.fld -> string list -> 
			   (string * string list) FieldStr.node FieldStr.report * string list)
	val writeForTree : (data FieldStr.fld ->
			    string * string list * string list -> string)

	val writerecTree : ((data -> string * string) ->
			    tinst -> (string * string list) FieldStr.node)

	val printTreeLeaves : tree -> unit

	val printOp : opportunity -> unit

	val prettyprintTreeLeaves : 
	    (string * Features.features * Features.binding -> string option) -> 
	    tree -> unit

	val writeTinstLeaves : tinst -> string
	val printTinstLeaves : tinst -> unit
	val writeprettyTinstLeaves : 
	    (string * Features.features * Features.binding -> string option) ->
	    tinst -> string

	val prettyprintTinstLeaves : 
	    (string * Features.features * Features.binding -> string option) ->
	    tinst -> unit

	val readTree : (data FieldStr.fld ->
			string list -> tree option * string list)

	val getTkind : tree -> tkind

	val start : Features.features * data -> tinst
	val combine : tinst * tree * cinfo -> tinst option
	val choices : tinst -> opportunity list

	val finalize : tinst -> tinst option
	val incompleteness : tinst -> int

	val opAtAddress : tinst * address -> opportunity option 
    end
