
signature WORD =
    sig
	structure Call : CALL
	structure Features : FEATURES
	structure Tag : TAG
	structure Formula : FDB

	type word
	type lexicon

	type word_part

	val wordFields : 
	    (Formula.Patheq.Modspec.collection -> 
	     word_part FieldStr.fld list)

	val fieldInit : string list

	datatype wordMatch =
	    M of {name: string list,
		  basic: bool,
		  parms: Call.call,
		  call: Call.call,
		  init: Call.init,
		  match: Features.features,
		  semantics: Formula.formula option,
		  presup: Formula.formula,
		  trees: Call.call list,
		  specinfo: Call.info,
		  oppo: Tag.opportunity}

	val printName : word -> unit
	val printWord : word -> unit
	val printLexicon : lexicon -> unit
	val printMatch : wordMatch -> unit

	val newLexicon : unit -> lexicon
	    
	val readWord : Formula.Patheq.Modspec.collection -> 
	    string list -> word option * string list
	val addWord : lexicon * word -> lexicon

	val specOrder :
	    ((Formula.Term.init Formula.Term.IntMap.intmap  *
	      Formula.formula ->
	      unit Formula.proof list) ->
	     lexicon -> lexicon)

	val matchWord : 
	    ((Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  * 
				       Formula.formula -> 
				       unit Formula.proof list)) *
	     (Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  *
				       Formula.formula ->
				       unit Formula.proof list))) ->
	    Tag.opportunity * Call.info ->
	    word -> wordMatch list

	val matchAll :
	    ((Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  * 
				       Formula.formula -> 
				       unit Formula.proof list)) *
	     (Formula.Patheq.pathpt * (Formula.Term.init Formula.Term.IntMap.intmap  *
				       Formula.formula ->
				       unit Formula.proof list))) ->
	    Tag.opportunity * Call.info  ->
	    lexicon -> wordMatch list

	val getCalls :
	    wordMatch list -> (Call.call * Call.info) list

	sharing type Tag.data = Call.call;
	    
		sharing  Call.Term = Formula.Term
		sharing Tag.Features = Features
    end
