
Debug.init ();

structure S = Symbol(structure HashTable = HashTable);

structure OSym = SplaySetFn(S.OrdSymbol);

structure DS = SplayMapFn(S.OrdSymbol);
    
structure F = Features(structure ListSort = ListMergeSort;
		       structure MySymbol = S;
		       structure OrdSet = OSym;
		       structure Dict = DS);
    
structure M = Morph(structure Features = F);
    
structure MDB = MorphDB(structure Morph = M;
			structure PolyHashTable = HashTable);
    
structure IF =  IntMapIntFifo(structure IntMap = MyIntMap;
			      structure Fifo = Fifo);

structure Mo = Modality(structure IntSet = MyIntSet;
			structure IntMap = MyIntMap);

structure Ms = Modspec(structure Modality = Mo;
		       structure Symbol = S;
		       structure HashTable = HashTable);

structure Ct = ConstraintTree(structure IntMap = MyIntMap;
			      structure IntSet = MyIntSet;
			      structure Fifo = IF);

structure Pe = Patheq(structure Modspec = Ms;
		      structure Ctree = Ct);
    
structure Tr  = ConstrainedTerm(structure Symbol = S;
				structure Patheq = Pe;
				structure IntMap = MyIntMap;
				structure IntSet = MyIntSet);

structure Cl = TermCall(structure Term = Tr);
    
structure Mb = FDBFo(structure Cterm = Tr;
		     structure Symbol = S);
    
structure As = Assume(structure Term = Tr);

structure T = Tag(structure Features = F;
		  type data = Cl.call;
		  type datastate = Cl.init;
		  val newcopyData = Cl.newcopyCall);
    
structure W = Word(structure Call = Cl;
		   structure Features = F;
		   structure Tag = T;
		   structure Formula = Mb);

structure Mc = Matchbank(structure Term = Tr;
			 structure Patheq = Pe);

structure Mn = Main(structure Lex = Lex1;
		    structure Read = SIOA;
		    structure Clock = Clock);
    
structure Cs = Constraint(structure Formula = Mb;
			  structure Call = Cl);

structure Tl = TagCall(structure Call = Cl;
		       structure Tag = T;
		       structure Formula = Mb);
    
structure Dv = Derive(structure Itag = Tl;
		      structure Word = W;
		      structure Constraint = Cs);
			   
structure RL = RecList;

structure CorE = Corped(structure MyFields = Fields);
    
structure TE = TreeEd(structure RL = RL);
structure TFE = TreeNFieldEd(structure FE = Fields;
			     structure TE = TE);

structure WWW = WordEdit(structure Word =W;
			 structure Fields =Fields;
			 structure Corped = CorE);
    
structure TTT = TreeEdit(structure Tl =Tl;
			 structure Fields =Fields;
			 structure TNFE = TFE;
			 structure Corped = CorE);
    
structure III = Interpreter(structure Fields =Fields;
			    structure Morph = MDB;
			    structure Derive = Dv;
			    structure Corped = CorE;
			    structure TNFE = TFE;
			    structure Lex = Lex1;
			    structure Main = Mn);
    
structure TOP = Toplevel(structure I =III;
			 structure Fields = Fields;
			 structure WE = WWW;
			 structure TE = TTT;
			 structure Main =Mn);
    
