
functor SocketStuff (structure Read : IOA) =
    struct
	exception Arguments
	exception Socket

	fun usage exec =
	    (print ("Usage: " ^ exec ^ "host port\n");
	     raise Arguments)

	val usock = ref NONE : 
	    (INetSock.inet, Socket.active Socket.stream) Socket.sock option ref
	val socket = ref NONE : 
	    (Read.reader * Read.writer) option ref

	fun init (exec, [ host, port ]) =
	    (let
		 val sock = INetSock.TCP.socket ()
		 val addr = (case NetHostDB.fromString host of
				 NONE => 
				     (print "Couldn't convert host to addr\n";
				      raise Socket)
			       | SOME a => a)
		 val p = (case Int.fromString port of
			      NONE =>
				  (print "Couldn't convert port to addr\n";
				   raise Socket)
			    | SOME i => i)
	     in 
		 Socket.connect(sock, INetSock.toAddr(addr, p));
		 usock := SOME sock;
		 socket := SOME(Read.wrapSocket sock)
	     end
		 handle OS.SysErr(s,_) => 
		     (print ("System call failed: " ^ s ^ "\n");
		      raise Socket))
	  | init (exec, _) = usage exec

	fun input () = 
	    case !socket of
		NONE => (print "Socket dead\n";
			 raise Socket)
	      | SOME(reader, _) =>
		    Read.getline reader

	fun output s = 
	    case !socket of 
		NONE => (print "Socket dead\n";
			 raise Socket)
	      | SOME (_, writer) => 
		    Read.put(writer, s)
		    handle Read.error s =>
			(print ("System call failed: " ^ s ^ "\n");
			 raise Socket)

	(* we always exit happily :*)
	fun finish () =
	    case !usock of
		NONE => OS.Process.success
	      | SOME fd => (Socket.close fd; OS.Process.success)
    end
