
Debug.init ();

structure S = Symbol(structure PolyHashTable = PolyHashTable;
		     structure StringUtil = StringUtil);

structure OS = SplaySet(S.OrdSymbol);

structure DS = SplayDict(S.OrdSymbol);
    
structure F = Features(structure ListSort = ListMergeSort;
		       structure MySymbol = S;
		       structure OrdSet = OS;
		       structure Dict = DS);
    
fun foo nil = (NONE,nil)
  | foo (a::x) = (SOME a, x)

structure M = Morph(structure Features = F);
    
structure MDB = MorphDB(structure Morph = M;
			structure PolyHashTable = PolyHashTable);
    
structure IF =  IntMapIntFifo(structure IntMap = MyIntMap;
			      structure Fifo = Fifo);

structure Mo = Modality(structure IntSet = IntSet;
			structure IntMap = IntMap);

structure Ms = Modspec(structure Modality = Mo;
		       structure Symbol = S;
		       structure PolyHashTable = PolyHashTable);

structure Ct = ConstraintTree(structure IntMap = IntMap;
			      structure IntSet = IntSet;
			      structure Fifo = IF);

structure Pe = Patheq(structure Modspec = Ms;
		      structure Ctree = Ct);
    
structure Tr  = ConstrainedTerm(structure Symbol = S;
				structure Patheq = Pe;
				structure IntMap = IntMap;
				structure IntSet = IntSet);

structure Cl = TermCall(structure Term = Tr);
    
structure Mb = FDBFo(structure Cterm = Tr;
		     structure Symbol = S);
    
structure As = Assume(structure Term = Tr);

structure T = Tag(structure Features = F;
		  type data = Cl.call;
		  type datastate = Cl.init;
		  val newcopyData = Cl.newcopyCall);
    
structure Word = Word(structure Call = Cl;
		      structure Features = F;
		      structure Tag = T;
		      structure Formula = Mb);

structure Tl = TagCall(structure Call = Cl;
		       structure Tag = T;
		       structure Formula = Mb);
    
structure Fields = Fields(structure FS = FieldStr);
structure RL = RecList(structure FS = FieldStr);
structure CorE = Corped(structure MyFields = Fields);
    
structure TE = TreeEd(structure RL = RL);
structure TFE = TreeNFieldEd(structure FE = Fields;
			     structure TE = TE);
    
local
    open Widget 

    fun tester server =
	let
	    val root = mkRoot server
	    val emptyModspec = Ms.newCollection ();
		
	    val fields = Tl.entryFields emptyModspec

	    val mkfields = #1 o (T.treeFields Tl.treeDataField)

	    fun nodeEdit (name, (kind, data), channel, die) =
		let
		    val newchannel = CML.channel ()
		    fun prop () = (CML.send(channel,
					    case (CML.accept newchannel) of 
						NONE => NONE
					      | SOME guy => SOME(kind, guy));
				   prop())

		    val result =
			Fields.mkFields(root,
					Fields.FI{name = "node: " ^ name ^ "(" ^ kind ^ ")",
						  minwidth = SOME 400,
						  done = newchannel,
						  die = die,
						  action = NONE,
						  fields = (map Fields.cvtField 
							    (ListUtil.zip (mkfields kind, data)))})

		in
		    CML.spawn prop;
		    Shell.init result;
		    result
		end

	    fun edit (name, (tree, data), channel, die) =
		let
		    val result = 
			TFE.mkTreeNField root
			(TFE.TFI{actions=TFE.AL{init = ("words", [ "fuck" ]),
						edit = nodeEdit,
						done = channel, 
						die = die},
				 name = name,
				 minwidth = SOME 300,
				 fields = (map Fields.cvtField
					   (ListUtil.zip (fields, data))),
				 tree = tree})
		in
		    Shell.init result;
		    result
		end

	    val allFields = fields @ [ Tl.treeEntryField ]

	    fun group s =
		(case FieldStr.rawSegment ("entry", allFields) s of
		     (FieldStr.GOT list, s') =>
			 let
			     val (data, treestuff) = ListUtil.split(length fields) list
			 in
			     case T.segmentTree Tl.treeDataField (hd treestuff) of
				 (FieldStr.GOT tree, nil) => 
				     SOME(CorE.CE{key = hd (hd data) handle Hd => "bogus",
						  data = (tree, map FieldStr.merge data)})
			       | _ =>
				     NONE
			 end
		   | (FieldStr.ERROR e, _) => 
			 (print e;
			  NONE)
		   | _ => NONE)
			
	    fun write (key, (tree, data))  = 
		let
		    fun wd (FieldStr.Tree {key, data=(kind,values), kids}) =
			T.writeForTree (Tl.treeDataField) (kind, values, map wd kids)
		    val treestr = wd tree
		in
		    FieldStr.unsegment ("entry", allFields) (data @ [treestr])
		end

	    val die = CML.channel ()
	    val done = CML.channel ()

	    val stuff = CorE.CI{actions = CorE.AL{init = Tl.fieldTreeInit,
						  edit = edit,
						  group = group,
						  write = write,
						  done = done,
						  die = die},
				elinits = nil}

	    val place = CorE.mkCorped root stuff
	in
	    Shell.init place;
	    CML.spawn(fn () => case CML.accept done of _ => (delRoot root;
							    RunCML.shutdown ()));
	    ()
	end
in
    fun spiff_main _ =
	(XDebug.init nil;
	 RunCML.doit (fn () => tester 
		    (* next to mac:  "158.130.8.75:0.0" *)
		    (* office   "158.130.8.145:0.0" *)
		    (* by psycholx lab: *) "158.130.8.70:0.0"
		      , SOME 10))

end
