
Debug.init ();

structure S = Symbol(structure HashTable = HashTable);

structure SS = SplaySetFn(S.OrdSymbol);

structure DS = SplayMapFn(S.OrdSymbol);
    
structure F = Features(structure ListSort = ListMergeSort;
		       structure MySymbol = S;
		       structure OrdSet = SS;
		       structure Dict = DS);
    
structure M = Morph(structure Features = F);
    
structure MDB = MorphDB(structure Morph = M;
			structure PolyHashTable = HashTable);
    
structure IF =  IntMapIntFifo(structure IntMap = MyIntMap;
			      structure Fifo = Fifo);

structure Mo = Modality(structure IntSet = MyIntSet;
			structure IntMap = MyIntMap);

structure Ms = Modspec(structure Modality = Mo;
		       structure Symbol = S;
		       structure HashTable = HashTable);

structure Ct = ConstraintTree(structure IntMap = MyIntMap;
			      structure IntSet = MyIntSet;
			      structure Fifo = IF);

structure Pe = Patheq(structure Modspec = Ms;
		      structure Ctree = Ct);
    
structure Tr  = ConstrainedTerm(structure Symbol = S;
				structure Patheq = Pe;
				structure IntMap = MyIntMap;
				structure IntSet = MyIntSet);

structure Cl = TermCall(structure Term = Tr);
    
structure Mb = FDBFo(structure Cterm = Tr;
		     structure Symbol = S);
    
structure As = Assume(structure Term = Tr);

structure T = Tag(structure Features = F;
		  type data = Cl.call;
		  type datastate = Cl.init;
		  val newcopyData = Cl.newcopyCall);
    
structure W = Word(structure Call = Cl;
		   structure Features = F;
		   structure Tag = T;
		   structure Formula = Mb);

structure Mc = Matchbank(structure Term = Tr;
			 structure Patheq = Pe);

structure Mn = Main(structure Lex = Lex1;
		    structure Read = SIOA;
		    structure Clock = Clock);
    
structure Cs = Constraint(structure Formula = Mb;
			  structure Call = Cl);

structure Tl = TagCall(structure Call = Cl;
		       structure Tag = T;
		       structure Formula = Mb);
    
structure Dv = Derive(structure Itag = Tl;
		      structure Word = W;
		      structure Constraint = Cs);
			   
structure Ml = SpudMainStuff(structure Main = Mn;
			     structure Derive = Dv;
			     structure Morphdb = MDB;

			     val init = (fn _ => ());
			     val input = (fn _ => TextIO.inputLine TextIO.stdIn);
			     val output = TextIO.print;
			     val finish = (fn _ => OS.Process.success));

structure Ss = SocketStuff(structure Read = SIOA);
    
structure Ms = SpudMainStuff(structure Main = Mn;
			     structure Derive = Dv;
			     structure Morphdb = MDB;

			     val init = Ss.init;
			     val input = Ss.input;
			     val output = Ss.output;
			     val finish = Ss.finish);
			     
val main = Mn.main (Ml.actions, Ml.init, Ml.finish, Ml.input, Ml.output);
val smain = Mn.main (Ms.actions, Ms.init, Ms.finish, Ms.input, Ms.output);    
