
Debug.init ();

structure S = Symbol(structure PolyHashTable = PolyHashTable;
		     structure StringUtil = StringUtil);

structure OS = SplaySet(S.OrdSymbol);

structure DS = SplayDict(S.OrdSymbol);
    
structure F = Features(structure ListSort = ListMergeSort;
		       structure MySymbol = S;
		       structure OrdSet = OS;
		       structure Dict = DS);
    
fun foo nil = (NONE,nil)
  | foo (a::x) = (SOME a, x)

structure M = Morph(structure Features = F);
    
structure MDB = MorphDB(structure Morph = M;
			structure PolyHashTable = PolyHashTable);
    
structure IF =  IntMapIntFifo(structure IntMap = MyIntMap;
			      structure Fifo = Fifo);

structure Mo = Modality(structure IntSet = IntSet;
			structure IntMap = IntMap);

structure Ms = Modspec(structure Modality = Mo;
		       structure Symbol = S;
		       structure PolyHashTable = PolyHashTable);

structure Ct = ConstraintTree(structure IntMap = IntMap;
			      structure IntSet = IntSet;
			      structure Fifo = IF);

structure Pe = Patheq(structure Modspec = Ms;
		      structure Ctree = Ct);
    
structure Tr  = ConstrainedTerm(structure Symbol = S;
				structure Patheq = Pe;
				structure IntMap = IntMap;
				structure IntSet = IntSet);

structure Cl = TermCall(structure Term = Tr);
    
structure Mb = FDBFo(structure Cterm = Tr;
		     structure Symbol = S);
    
structure As = Assume(structure Term = Tr);

structure T = Tag(structure Features = F;
		  type data = Cl.call;
		  type datastate = Cl.init;
		  val newcopyData = Cl.newcopyCall);
    
structure Word = Word(structure Call = Cl;
		      structure Features = F;
		      structure Tag = T;
		      structure Formula = Mb);

structure Fields = Fields(structure FS = FieldStr);
structure Corped = Corped(structure MyFields = Fields);
    
local
    open Widget Corped

    fun tester server =
	let
	    val root = mkRoot server
	    val emptyModspec = Ms.newCollection ();
	    val fields = Word.wordFields (emptyModspec);
		
	    fun edit (name, data, channel, die) =
		let
		    val result =
			Fields.mkFields(root,
					Fields.FI{name = "word: " ^ name,
						  minwidth = SOME 400,
						  done = channel,
						  die = die,
						  action = NONE,
						  fields = (map Fields.cvtField 
							    (ListUtil.zip (fields, data)))})

		in
		    Shell.init result;
		    result
		end

	    fun group s =
		(case FieldStr.segment ("word", fields) s of
		     (FieldStr.GOT (name :: x), s') => (SOME (CE{key=name, data= name :: x}))
		   | (FieldStr.GOT nil, s') => (SOME (CE{key="bogus", data= nil}))
		   | (FieldStr.EMPTY, s') => (NONE)
		   | (FieldStr.ERROR e, _) =>
			 (print e; (NONE)))

	    fun write (x,s) = FieldStr.unsegment ("word", fields) s

	    val die = CML.channel()
	    val done  = CML.channel()

	    val stuff = CI{actions = AL{init = Word.fieldInit,
					edit = edit,
					group = group,
					write = write,
					done = done,
					die = die},
			   elinits = nil
(*
			   elinits = [ CE{key = "hello",
					  data = ["hello", "true", "alpha", "s(greeting)", "()",
						  "true", "true", "true", "hello"] } ]
*)
			   }

	    val place = mkCorped root stuff
	in
	    CML.spawn(fn () => case CML.accept done of _ => (delRoot root;
							     RunCML.shutdown ()));
	    ()
	end
in
    fun wed_main _ =
	(XDebug.init nil;
	 RunCML.doit (fn () => tester 
		    (* next to mac:  "158.130.8.75:0.0" *)
		    (* office *)  "158.130.8.145:0.0" 
		      , SOME 10))

end
