(* text_list.sml
 *
 * COPYRIGHT (c) 1991,1992 by AT&T Bell Laboratories
 *
 * List widget, for text lists.
 *
 * modified ms 6/97
 *)

signature REC_LIST =
  sig

    exception BadIndex
    exception MultipleChoices

    type 'a rec_list

    datatype 'a list_evt = 
	Set of int * string * 'a 
      | Unset of int * string  * 'a

    datatype list_mode = OneSet | MultiSet

    val mkRList : Widget.root -> {
	    mode : list_mode,
	    backgrnd : Widget.EXB.color option,
	    foregrnd : Widget.EXB.color option,
	    item : 'a FieldStr.node
	  } -> 'a rec_list

    val evtOf : 'a rec_list -> 'a list_evt CML.event
    val widgetOf : 'a rec_list -> Widget.widget

    val setChosen : 'a rec_list -> (int * bool) list -> unit
    val setActive : 'a rec_list -> (int * bool) list -> unit
    val setData : 'a rec_list -> (int * 'a) list -> unit

    val getChosen : 'a rec_list -> int list
    val getState : 'a rec_list -> Widget.wstate list

    val addChild : 'a rec_list -> (int * 'a FieldStr.node) -> unit
    val listItems : 'a rec_list -> 'a FieldStr.node
  end (* REC_LIST *)
