
signature TREE_ED =
    sig
	structure R : REC_LIST

	datatype 'a actions =
	    AL of {init : 'a,
		   edit : string * 'a * 'a option CML.chan * bool CML.chan -> Shell.shell,
		   done : 'a FieldStr.node option CML.chan,
		   die : bool CML.chan}

	datatype 'a treeinfo =
	    TI of {withMenu : bool,
		   actions: 'a actions,
		   elinit: 'a FieldStr.node}

	val mkSimpleTreeD : Widget.root -> '2a treeinfo -> Widget.widget
	val mkTreeD : Widget.root -> '2a treeinfo -> Shell.shell
    end

signature TREE_N_FIELD_ED =
    sig
	structure TE : TREE_ED
	structure FE : FIELDS

	datatype 'a actions =
	    AL of {init : 'a,
		   edit : string * 'a * 'a option CML.chan * bool CML.chan -> Shell.shell,
		   done : ('a FieldStr.node * string list) option CML.chan,
		   die : bool CML.chan}

	datatype 'a tfinfo =
	    TFI of {actions: 'a actions,
		    name: string,
		    minwidth : int option,
		    fields : FE.field list,
		    tree : 'a FieldStr.node}

	val mkTreeNField : Widget.root -> 'a tfinfo -> Shell.shell
	val mkTreeNFieldView : Widget.root -> 'a tfinfo -> Shell.shell
    end
